<template>
  <ui-clickable
    :disabled="disabled"
    :to="to"
    :href="href"
    :type="type"
    :target="target"

    v-bind="componentProps"

    class="ui-button"
    @click="handleClick"
  >
    <slot />
  </ui-clickable>
</template>

<script lang="ts">
  import type { RouteLocationRaw } from 'vue-router'
  import { computed, defineComponent, PropType } from 'vue'
  import { uiCalcRounded } from '../../utils/uiCalcRounded'
  import { UiClickable } from '../UiClickable'
  import { UI_BUTTON_VARIANTS } from './constants'
  import { UiButtonValiantProp } from './types'

  type ButtonProps = {
    class: Record<string, boolean>
    style: Partial<CSSStyleDeclaration>,
  }

  export default defineComponent({
    name: 'ui-button',
    props: {
      type: {
        type: String as PropType<'button' | 'submit' | 'reset'>,
        default: 'button',
      },
      disabled: {
        type: Boolean,
        default: false,
      },
      size: {
        type: Number,
        default: 64,
      },
      to: {
        type: Object as PropType<RouteLocationRaw>,
      },
      href: {
        type: String,
      },
      target: {
        type: String,
      },
      variant: {
        type: String as PropType<UiButtonValiantProp>,
        validator: (value: UiButtonValiantProp) => UI_BUTTON_VARIANTS.includes(value),
        default: 'green-atomic',
      },
      rounded: {
        type: Boolean,
      },
    },
    setup(props) {
      const componentProps = computed(() => {
        const {size, rounded} = props
        const buttonProps: ButtonProps = {
          class: {
            '-disabled': props.disabled,
            [`-size-${props.size}`]: true,
            [`-${props.variant}`]: true,
          },
          style: {
            borderRadius: `${rounded ? size / 2 : uiCalcRounded(size)}px`,
            height: `${size}px`,
            minWidth: `${size}px`,
          },
        }

        return buttonProps
      })

      const componentName = computed(() => {
        return props.to ? 'router-link' : props.href ? 'a' : 'button'
      })

      const handleClick = (event: Event) => {
        if (props.disabled) {
          event.preventDefault()
          event.stopPropagation()
        }
      }

      return {
        componentProps,
        componentName,
        handleClick,
      }
    },
    components: {
      UiClickable,
    }
  })
</script>

<style>
  .ui-button {
    @apply uikit-block uikit-uppercase uikit-select-none uikit-transition-colors uikit-text-12;
    padding: 0 8px 0 8px;
    border: none;
  }

  .ui-button.-disabled {
    border: none;
    cursor: not-allowed;
    @apply uikit-bg-gray uikit-bg-opacity-30 uikit-text-gray;
  }

  .ui-button:not(.-disabled) {
    cursor: pointer;
  }

  .ui-button:not(.-disabled):hover {
    @apply uikit-opacity-100;
  }

  .ui-button {
    @apply uikit-inline-flex uikit-justify-center uikit-items-center uikit-transition uikit-duration-150;
  }

  .ui-button:not(.-disabled).-white {

    @apply uikit-bg-white-lazurit-gradient hover:uikit-opacity-[0.85] active:uikit-opacity-[0.65] uikit-text-black;
  }

  .ui-button:not(.-disabled).-green-atomic {
    @apply uikit-bg-green-atomic uikit-text-black;
  }

  .ui-button:not(.-disabled).-violet {
    @apply uikit-bg-violet uikit-text-white hover:uikit-bg-violet-400 active:uikit-bg-violet-600;
  }

  .ui-button:not(.-disabled).-gray {
    @apply uikit-bg-gray uikit-bg-opacity-20 hover:uikit-bg-opacity-30 active:uikit-bg-opacity-10 uikit-text-white;
  }

  .ui-button:not(.-disabled).-red {
    @apply uikit-bg-red uikit-text-white hover:uikit-bg-red-400 active:uikit-bg-red-600;
  }

  .ui-button:not(.-disabled).-metamask {
    @apply uikit-bg-orange-300 uikit-bg-opacity-10 uikit-text-white hover:uikit-bg-opacity-20 active:uikit-bg-opacity-5;
  }
</style>
